/*
xlstfnt Version 0.2.0 - List X Windows Fonts
Copyright (C) 2001-2010  dondalah721@yahoo.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <X11/Xlib.h>
#include <X11/keysymdef.h>
#include <assert.h>
#include <unistd.h>

#define NIL (0)
#define SCRW 240
#define SCRH 120

Display *dpy;

void putstx(pgm)
char *pgm;
   {
   fprintf(stderr,"Usage: %s [mask]\n", pgm);
   fprintf(stderr,"Where mask is the font name mask.\n", pgm);
   exit(1);
   } /* putstx */

/* X Windows code is based on: */
/* http://tronche.lri.fr:8000/gui/x/xlib-tutorial/2nd-program-anatomy.html */

int main(argc,argv)
int argc;
char **argv;
   {
   int i,fnts;
   char **lst;
   char fntmask[256];
   if (argc == 1)
      {
      strcpy(fntmask,"*");
      } /* no fontname mask */
   else if (argc == 2)
      {
      strcpy(fntmask,*(argv+1));
      } /* 1 parm */
   else putstx(*argv);
   dpy = XOpenDisplay(NIL);

   if (dpy == NULL)
      {
      fprintf(stderr,"X Windows failure\n");
      exit(1);
      } /* if X Windows is not active */

   assert(dpy);

   lst = (char **) XListFonts(dpy,fntmask,999999,&fnts);
   printf("\"%s\"  Total fonts %d\n",
      fntmask, fnts);
   for (i=0;i<fnts;i++)
      {
      printf("%4d: %s\n", i, lst[i]);
      }
   return(0);
   } /* main */
